import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { SysLog, SysLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageSysLog(params: SysLogParam) {
  const res = await request.get<ApiResult<PageResult<SysLog>>>(
    THINK_API_URL + '/think/sys-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listSysLog(params?: SysLogParam) {
  const res = await request.get<ApiResult<SysLog[]>>(
    THINK_API_URL + '/think/sys-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addSysLog(data: SysLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/sys-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateSysLog(data: SysLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/sys-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeSysLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/sys-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchSysLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/sys-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getSysLog(id: number) {
  const res = await request.get<ApiResult<SysLog>>(
    THINK_API_URL + '/think/sys-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
